]> git.ipfire.org Git - thirdparty/squid.git/blob - bootstrap.sh
Revert rev 9922 - grep arguments not portable
[thirdparty/squid.git] / bootstrap.sh
1 #!/bin/sh
2 # Used to setup the configure.in, autoheader and Makefile.in's if configure
3 # has not been generated. This script is only needed for developers when
4 # configure has not been run, or if a Makefile.am in a non-configured directory
5 # has been updated
6
7 # Autotool versions preferred. To override either edit the script
8 # to match the versions you want to use, or set the variables on
9 # the command line like "env acver=.. amver=... ./bootstrap.sh"
10 acversions="${acver:-2.63 2.62 2.61}"
11 amversions="${amver:-1.11 1.10 1.9}"
12 ltversions="${ltver:-2 1.5 1.4}"
13
14 check_version()
15 {
16 eval $2 --version 2>/dev/null | grep -i "$1.* $3" >/dev/null
17 }
18
19 show_version()
20 {
21 tool=$1
22 found="NOT_FOUND"
23 shift
24 versions="$*"
25 for version in $versions; do
26 for variant in "" "-${version}" "`echo $version | sed -e 's/\.//g'`"; do
27 if check_version $tool ${tool}${variant} $version; then
28 found="${version}"
29 break
30 fi
31 done
32 if [ "x$found" != "xNOT_FOUND" ]; then
33 break
34 fi
35 done
36 if [ "x$found" = "xNOT_FOUND" ]; then
37 found="??"
38 fi
39 echo $found
40 }
41
42 find_variant()
43 {
44 tool=$1
45 found="NOT_FOUND"
46 shift
47 versions="$*"
48 for version in $versions; do
49 for variant in "" "-${version}" "`echo $version | sed -e 's/\.//g'`"; do
50 if check_version $tool ${tool}${variant} $version; then
51 found="${variant}"
52 break
53 fi
54 done
55 if [ "x$found" != "xNOT_FOUND" ]; then
56 break
57 fi
58 done
59 if [ "x$found" = "xNOT_FOUND" ]; then
60 echo "WARNING: Cannot find $tool version $versions" >&2
61 echo "Trying `$tool --version | head -1`" >&2
62 found=""
63 fi
64 echo $found
65 }
66
67 bootstrap() {
68 if "$@"; then
69 true # Everything OK
70 else
71 echo "$1 failed"
72 echo "Autotool bootstrapping failed. You will need to investigate and correct" ;
73 echo "before you can develop on this source tree"
74 exit 1
75 fi
76 }
77
78 bootstrap_libtoolize() {
79 ltver=$1
80
81 # TODO: when we have libtool2, tell libtoolize where to put its files
82 # instead of manualy moving files from ltdl to lib/libLtdl
83 if egrep -q '^[[:space:]]*AC_LIBLTDL_' configure.in
84 then
85 if libtoolize$ltver --help | grep -q -- --ltdl.=; then
86 ltdl="--ltdl=lib/libLtdl"
87 else
88 ltdl="--ltdl"
89 copy_libltdl=1
90 fi
91 else
92 ltdl=""
93 fi
94
95 bootstrap libtoolize$ltver $ltdl --force --copy --automake
96
97 # customize generated libltdl, if any
98 if test -d libltdl && [ $copy_libltdl ]
99 then
100 src=libltdl
101
102 # do not bundle with the huge standard license text
103 rm -fv $src/COPYING.LIB
104 makefile=$src/Makefile.in
105 sed 's/COPYING.LIB/ /g' $makefile > $makefile.new;
106 chmod u+w $makefile
107 mv $makefile.new $makefile
108 chmod u-w $makefile
109
110 dest=lib/libLtdl
111 # move $src to $dest
112 if test -d $dest # already exists
113 then
114 echo "Updating $dest from $src."
115 chmod u+w $dest/*
116 mv $src/* $dest/
117 rmdir $src
118 else
119 echo "Creating $dest from $src."
120 mv $src $dest
121 fi
122 fi
123 }
124
125 # Adjust paths of required autool packages
126 amver=`find_variant automake ${amversions}`
127 acver=`find_variant autoconf ${acversions}`
128 ltver=`find_variant libtool ${ltversions}`
129
130 # Produce debug output about what version actually found.
131 amversion=`show_version automake ${amversions}`
132 acversion=`show_version autoconf ${acversions}`
133 ltversion=`show_version libtool ${ltversions}`
134
135 # Set environment variable to tell automake which autoconf to use.
136 AUTOCONF="autoconf${acver}" ; export AUTOCONF
137
138 echo "automake ($amversion) : automake$amver"
139 echo "autoconf ($acversion) : autoconf$acver"
140 echo "libtool ($ltversion) : libtool$ltver"
141
142 for dir in \
143 "" \
144 lib/libTrie \
145 helpers/negotiate_auth/squid_kerb_auth
146 do
147 if [ -z "$dir" ] || [ -d $dir ]; then
148 if (
149 echo "Bootstrapping $dir"
150 cd ./$dir
151 if [ -n "$dir" ] && [ -f bootstrap.sh ]; then
152 ./bootstrap.sh
153 elif [ ! -f $dir/configure ]; then
154 # Make sure cfgaux exists
155 mkdir -p cfgaux
156
157 # Bootstrap the autotool subsystems
158 bootstrap aclocal$amver
159 bootstrap autoheader$acver
160 bootstrap_libtoolize $ltver
161 bootstrap automake$amver --foreign --add-missing --copy -f
162 bootstrap autoconf$acver --force
163 fi ); then
164 : # OK
165 else
166 exit 1
167 fi
168 fi
169 done
170
171 # Fixup autoconf recursion using --silent/--quiet option
172 # autoconf should inherit this option whe recursing into subdirectories
173 # but it currently doesn't for some reason.
174 if ! grep "configure_args --quiet" configure >/dev/null; then
175 echo "Fixing configure recursion"
176 ed -s configure <<'EOS' >/dev/null || true
177 /ac_sub_configure_args=/
178 +1
179 i
180 # Add --quiet option if used
181 test "$silent" = yes &&
182 ac_sub_configure_args="$ac_sub_configure_args --quiet"
183 .
184 w
185 EOS
186 fi
187
188 echo "Autotool bootstrapping complete."